/*
 * File: MediaPlayer.c
 * Date: 19 aug 2011
 * Time: 18:12:11
 * Generated by TismTool version 0.7
 */
#include <string.h>
#include <stdlib.h>
#include "OSAL_Gen.h"
#include "OSAL_Thread.h"
#include "Tsm.h"
#include "TsmGen.h"
#include "TsmException.h"
#include "TsmSystem.h"

void ArgsHandle( int argc, char* argv[] )
{
  int i;

  for ( i=0; i<argc; i++ )
  {
    char* ca = argv[i];
    if ( ( strlen(ca) >= 2 ) && ( ca[ 0 ] == '-' ) )
    {
      switch ( ca[1] )
      {
      case 'l' :
        if ( ( strlen(ca) >= 4 ) && ( ca[ 2 ] == '=' ) )
        {
          int ll = atoi( ca + 3 );
          Tsm_SetLogLevel( ll );
        }
        break;
      case 'C' :
        if ( strlen(ca) >= 3 )
        {
          Tsm_SetLogConsole( ca[ 2 ] == '+' );
        }
        break;
      case 'L' :
        if ( strlen(ca) >= 3 )
        {
          Tsm_SetLogFile( ca[ 2 ] == '+' );
        }
        break;
      case 'S' :
        if ( strlen(ca) >= 3 )
        {
          Tsm_SetSeqFile( ca[ 2 ] == '+' );
        }
        break;
      }
    }
  }
}

int main( int argc, char* argv[] )
{
  int           xc = 0;
  OSAL_Thread*  oThread;
  int           rv;
  TsmSystem*    ts;

  ArgsHandle( argc, argv );

  OSAL_Initialise();
  oThread = OSAL_GetCurrentThread();
  rv = setjmp( oThread->JmpBuf );

  switch ( rv )
  {
  case TsmException_OK :
    ts = TsmSystem_Ctor( NULL );
    ts->Activate( (TsmExecComponent*) ts );
    ts->Execute( (TsmExecComponent*) ts );
    ts->Deactivate( (TsmExecComponent*) ts );
    ts->Dtor( (TsmObject*) ts );
    break;

  case TsmException_QUIT :
    Tsm_ShowException( "*** TsmSystem Exception ***" );
    xc = 1;
    break;
  }

  OSAL_Terminate();
  return xc;
}
