/*
 * TismTool © Tis Veugen, 2010-2011
 * Simulation, Verification
 *
 * TsmAComponent.c
 * version 1
 */
#include <stdio.h>
#include "TsmGen.h"
#include "TsmComponent.h"
#include "TsmAComponent.h"
#include "TsmThread.h"
#include "TsmThreadType.h"

/**
 * Active Component
 */
TsmAComponent* TsmAComponent_Ctor( void )
{
  TsmAComponent* this = (TsmAComponent*) Tsm_Malloc( sizeof(TsmAComponent) );
  TsmAComponent_Ftor( this );
  return this;
}

void TsmAComponent_Ftor( TsmAComponent* this )
{
  TsmComponent_Ftor( (TsmComponent*) this );
  this->Class = "TsmAComponent";

  this->Gtor = (Tsm_pfObj) TsmAComponent_Gtor;
  this->GetThread = TsmAComponent_GetThread;
  this->IsActive = (TsmBool (*)( TsmComponent* )) TsmAComponent_IsActive;
  this->ThreadId = (void (*)( TsmComponent*, TsmStr )) TsmAComponent_ThreadId;
  this->TsmConnectAll = (void (*)( TsmComponent*, void* )) TsmAComponent_TsmConnectAll;
  this->TsmPrepare = (Tsm_pfClVoid) TsmAComponent_TsmPrepare;
  this->TsmRun = (Tsm_pfClVoid) TsmAComponent_TsmRun;
  this->TsmHalt = (Tsm_pfClVoid) TsmAComponent_TsmHalt;
  this->TsmCease = (Tsm_pfClVoid) TsmAComponent_TsmCease;

  TsmThread_Ftor( &this->mThread, TsmThreadType_THREAD );
}

void TsmAComponent_Gtor( TsmAComponent* this )
{
  TsmThread_Gtor( &this->mThread );
  TsmComponent_Gtor( (TsmComponent*) this );
}

TsmThread* TsmAComponent_GetThread( TsmAComponent* this )
{
  return &this->mThread;
}

TsmBool TsmAComponent_IsActive( TsmAComponent* this )
{
  return TRUE;
}

void TsmAComponent_ThreadId( TsmAComponent* this, TsmStr sout )
{
  sprintf( sout, ",%d", this->mThread.mSequence );
}

void TsmAComponent_TsmConnectAll( TsmAComponent* this, void* oObject )
{
  TsmComponent_TsmConnectAll( (TsmComponent*) this, this->mThread.GetIntQueue( &this->mThread ) );
}

void TsmAComponent_TsmPrepare( TsmAComponent* this, void* oObject )
{
  this->mThread.Prepare( &this->mThread, this->TsmName );
}

void TsmAComponent_TsmRun( TsmAComponent* this, void* oObject )
{
  this->mThread.Run( &this->mThread );
}

void TsmAComponent_TsmHalt( TsmAComponent* this, void* oObject )
{
  this->mThread.Halt( &this->mThread );
}

void TsmAComponent_TsmCease( TsmAComponent* this, void* oObject )
{
  this->mThread.Cease( &this->mThread );
}
