/*
 * TismTool © Tis Veugen, 2010-2011
 * Simulation, Verification
 *
 * TsmAComponent.h
 * version 1
 */
#ifndef TSM_ACOMPONENT_H
#define TSM_ACOMPONENT_H
/**
 * Active Component
 */
#ifdef __cplusplus
extern "C" {
#endif

#include "TsmGen.h"
#include "TsmComponent.h"
#include "TsmThread.h"

typedef struct TsmAComponentStruct /* : TsmComponent */
{
#include "TsmAComponent_fields.h"
} TsmAComponent;

TsmAComponent*  TsmAComponent_Ctor( void );
void            TsmAComponent_Ftor( TsmAComponent* this );
void            TsmAComponent_Gtor( TsmAComponent* this );

TsmThread*      TsmAComponent_GetThread( TsmAComponent* this );
TsmBool         TsmAComponent_IsActive( TsmAComponent* this );
void            TsmAComponent_ThreadId( TsmAComponent* this, TsmStr sout );
void            TsmAComponent_TsmConnectAll( TsmAComponent* this, void* oObject );
void            TsmAComponent_TsmPrepare( TsmAComponent* this, void* oObject );
void            TsmAComponent_TsmRun( TsmAComponent* this, void* oObject );
void            TsmAComponent_TsmHalt( TsmAComponent* this, void* oObject );
void            TsmAComponent_TsmCease( TsmAComponent* this, void* oObject );
#ifdef __cplusplus
}
#endif 
#endif
