/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmClass.h
 * version 2
 */
#ifndef TSM_CLASS_H
#define TSM_CLASS_H

#ifdef __cplusplus
extern "C" {
#endif

#include "TsmGen.h"
#include "TsmBase.h"
#include "TsmFsm.h"
#include "TsmNativeLists.h"
#include "TsmTrigger.h"

#define TsmClass_NativePortId (-1)

typedef struct TsmClassStruct /* : TsmBase */
{
#include "TsmClass_fields.h"
} TsmClass;

typedef void (*Tsm_pfClVoid)( TsmClass*, void* );
typedef void (*Tsm_pfClTrgr)( TsmClass*, TsmTrigger* );
typedef void (*Tsm_pfClReqIfc)( TsmClass*, char*, struct TsmInterfacePortStruct* );
typedef struct TsmInterfacePortStruct* (*Tsm_pfClPrvIfc)( TsmClass*, char* );

TsmClass* TsmClass_Ctor( void );
void      TsmClass_Ftor( TsmClass* this );
void      TsmClass_Gtor( TsmClass* this );
void      TsmClass_SetProxyUser( TsmClass* this, TsmClass* oProxyUser );
struct TsmInterfacePortStruct* TsmClass_GetProvidedInterface( TsmClass* this, char* sPortName );
void      TsmClass_SetRequiredInterface( TsmClass* this, char* sPortName, struct TsmInterfacePortStruct* oProvidedInterface );
void      TsmClass_ExecuteTrigger( TsmClass* this, TsmTrigger* oTrigger );
void      TsmClass_ExecuteNative( TsmClass* this, int iCmd );
void      TsmClass_TsmInitialise( TsmClass* this, void* oObject );
void      TsmClass_TsmConnect( TsmClass* this, void* oObject );
void      TsmClass_TsmPrepare( TsmClass* this, void* oObject );
void      TsmClass_TsmRun( TsmClass* this, void* oObject );
void      TsmClass_TsmHalt( TsmClass* this, void* oObject );
void      TsmClass_TsmCease( TsmClass* this, void* oObject );
void      TsmClass_TsmDisconnect( TsmClass* this, void* oObject );
void      TsmClass_TsmTerminate( TsmClass* this, void* oObject );
void      TsmClass_TsmMention( TsmClass* this, void* oObject );
void      TsmClass_TsmReset1( TsmClass* this );
void      TsmClass_TsmReset2( TsmClass* this );
void      TsmClass_TsmSnap( TsmClass* this, TsmStr sout );
void      TsmClass_TsmCheckVisit( TsmClass* this );
TsmBool   TsmClass_IsTsmProxy( TsmClass* this );
TsmBool   TsmClass_IsTsmProxyUser( TsmClass* this );

#ifdef __cplusplus
}
#endif 
#endif
