/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmGen.c
 * version 1
 */
#include <stdlib.h>
#include <string.h>
#include "TsmGen.h"
#include "TsmException.h"

void Tsm_Free( void* p )
{
  free( p );
}

void* Tsm_Malloc( size_t n )
{
  void* p = malloc( n );
  if ( NULL == p )
  {
    TsmException_Quit( "Tsm_Malloc" );
  }
  return p;
}

void* Tsm_Realloc( void* p, size_t n )
{
  p = realloc( p, n );
  if ( NULL == p )
  {
    TsmException_Quit( "Tsm_Realloc" );
  }
  return p;
}

char* Tsm_Restring( char* p )
{
  p = realloc( p, strlen(p)+1 );
  if ( NULL == p )
  {
    TsmException_Quit( "Tsm_Restring" );
  }
  return p;
}
