/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmSubFsm.h
 * version 3
 */
#ifndef TSM_SUBFSM_H
#define TSM_SUBFSM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "TsmGen.h"
#include "TsmState.h"
#include "TsmFsm.h"
#include "TsmHandler.h"

typedef struct TsmSubFsmStruct /* : TsmState */
{
#include "TsmSubFsm_fields.h"
} TsmSubFsm;

typedef void (*Tsm_pfSubFsmHdlr)( TsmSubFsm* this, TsmHandler* oHandler );

TsmSubFsm*  TsmSubFsm_Ctor( void );
void        TsmSubFsm_Ftor( TsmSubFsm* this );
void        TsmSubFsm_Gtor( TsmSubFsm* this );

void        TsmSubFsm_Initial( TsmSubFsm* this, TsmHandler* oHandler );
void        TsmSubFsm_ExecuteTrigger( TsmSubFsm* this, TsmHandler* oHandler );
void        TsmSubFsm_ExecuteTriggerSubFsm( TsmSubFsm* this, TsmHandler* oHandler );
void        TsmSubFsm_AtMyExit( TsmSubFsm* this, TsmHandler* oHandler );
void        TsmSubFsm_AtExit( TsmSubFsm* this, TsmHandler* oHandler );
void        TsmSubFsm_TsmSnap( TsmSubFsm* this, TsmStr sout );
void        TsmSubFsm_TsmCheckVisit( TsmSubFsm* this );
TsmFsm*     TsmSubFsm_SwapFsms( TsmSubFsm* this, TsmFsm* Target2Source );
TsmBool     TsmSubFsm_IsTsmSubFsm( TsmSubFsm* this );

#ifdef __cplusplus
}
#endif 
#endif
