/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmMutex.c
 * version 2
 */
#include "OSAL_Gen.h"
#include "OSAL_MutexSem.h"
#include "TsmGen.h"
#include "TsmMutex.h"
#include "TsmException.h"

void TsmMutex_Ftor( TsmMutex* this )
{
  this->mbExclusive = FALSE;    
  this->mMutex = OSAL_MutexSemCreate();
  if ( OSAL_HANDLE_INVALID == this->mMutex )
  {
    TsmException_Quit( "TsmMutex_Ftor: OSAL_MutexSemCreate" );
  }
}

void TsmMutex_Gtor( TsmMutex* this )
{
  if ( OSAL_HANDLE_INVALID != this->mMutex )
  {
    OSAL_MutexSemDelete( this->mMutex );
    this->mMutex = OSAL_HANDLE_INVALID;
  }
}

void TsmMutex_WaitOne( TsmMutex* this )
{
  OSAL_MutexSemLock( this->mMutex );
  this->mbExclusive = TRUE;    
}

void TsmMutex_Release( TsmMutex* this )
{
  this->mbExclusive = FALSE;    
  OSAL_MutexSemUnlock( this->mMutex );
}

void TsmMutex_Reset( TsmMutex* this )
{
  OSAL_MutexSemReset( this->mMutex );
}
