#---------------------------------------------------------
#
# compiler-opts.mak
#
#---------------------------------------------------------

#---------------------------------------------------------
# Debug Options for build
#---------------------------------------------------------
#DEBUG_OPTS = -g -O0
DEBUG_OPTS = -O1
DEBUG_LEVEL = 3

#---------------------------------------------------------
# Warning Level Configuration
#---------------------------------------------------------
WARNINGS=-Wall -pedantic -Wstrict-prototypes

#---------------------------------------------------------
# Target Defines for the OS, Hardware Arch, etc..
#---------------------------------------------------------
# OS_LINUX:
OS=LINUX
# OS_WINDOWS:
# OS already definded

TARGET_DEFS=-D$(OS)  

#---------------------------------------------------------
# gcc options for compiling and dependency generation
#---------------------------------------------------------
COPTS = $(TARGET_DEFS) $(WARNINGS)

#---------------------------------------------------------
# Host Development System and Toolchain definitions
#---------------------------------------------------------

#
# Host OS utils
#
# OS_LINUX:
RM=rm -f
CP=cp
# OS_WINDOWS:
#RM=del
#CP=copy

#
# Compiler tools
#
COMPILER=gcc
COMPILERCPP=g++
AR=ar
