#---------------------------------------------------------
#
# make-rules.mak
#
#---------------------------------------------------------

# OS_LINUX:
LIB_TARGET = ../../lib/$(TARGET)
# OS_WINDOWS:
#LIB_TARGET = ..\..\lib\$(TARGET)

#---------------------------------------------------------
# The default "make" target is the subsystem object module.
#---------------------------------------------------------
default::$(TARGET)

#---------------------------------------------------------
# Compiler rule
#---------------------------------------------------------
.cpp.o:
	$(COMPILERCPP) $(INCLUDE_PATH) $(COPTS) $(DEBUG_OPTS) -DOS_DEBUG_LEVEL=$(DEBUG_LEVEL) -c -o $@ $<

.c.o:
	$(COMPILER) $(INCLUDE_PATH) $(COPTS) $(DEBUG_OPTS) -DOS_DEBUG_LEVEL=$(DEBUG_LEVEL) -c -o $@ $<

#---------------------------------------------------------
# Rule to generate the dependency list
#---------------------------------------------------------
depend: $(SOURCES) $(SOURCESCPP)
	$(COMPILER) -MM $(INCLUDE_PATH) $(COPTS) $(DEBUG_OPTS) -DOS_DEBUG_LEVEL=$(DEBUG_LEVEL) -c $^ > $(SUBSYS).d

#---------------------------------------------------------
# Create archive rule
#---------------------------------------------------------
$(TARGET): $(OBJS) $(OBJSCPP)
	$(AR) -cvq $(TARGET) $(OBJS) $(OBJSCPP)
	$(CP) $(TARGET) $(LIB_TARGET)
	$(CPCOMPONENTSSPECIFICSLIB)

#---------------------------------------------------------
# Make clean rule
#---------------------------------------------------------
clean:
	echo cleaning -$(RM)
	-$(RM) *.d
	-$(RM) *.o
	-$(RM) *.a

#---------------------------------------------------------
# Include the dependency list
#---------------------------------------------------------
-include $(SUBSYS).d
